package cn.x47.handle;


import cn.x47.model.RIPEntry;
import cn.x47.model.RIPPacket;
import cn.x47.service.RoutingTable;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.SimpleChannelInboundHandler;

public class RIPServerHandler extends SimpleChannelInboundHandler<RIPPacket> {

    @Override
    protected void channelRead0(ChannelHandlerContext ctx, RIPPacket msg) throws Exception {
        if (msg.getCommand() == 2) { // Response
            for (RIPEntry entry : msg.getEntries()) {
                // 更新本地路由表
                updateRoutingTable(entry);
            }
        } else if (msg.getCommand() == 1) { // Request
            // 处理请求，可能需要发送响应包
            // ...
        }
    }

    private void updateRoutingTable(RIPEntry entry) {
        // 实现路由表更新逻辑
        // 这里只是示例，实际需要处理路由添加、更新、超时等逻辑
        RoutingTable.getInstance().updateRoute(entry);
        System.out.println("Updated route: " + entry.getIpAddress().getHostAddress() +
                " via " + entry.getNextHop().getHostAddress() +
                " metric: " + entry.getMetric());

    }
}
