package cn.x47.service;


import cn.x47.handle.RIPPacketEncoder;
import cn.x47.model.RIPPacket;
import io.netty.bootstrap.Bootstrap;
import io.netty.channel.ChannelFuture;
import io.netty.channel.ChannelInitializer;
import io.netty.channel.ChannelOption;
import io.netty.channel.nio.NioEventLoopGroup;
import io.netty.channel.socket.DatagramChannel;
import io.netty.channel.socket.nio.NioDatagramChannel;


public class RIPClient {

    private final Bootstrap bootstrap;
    private final NioEventLoopGroup group;

    public RIPClient() {
        group = new NioEventLoopGroup();
        bootstrap = new Bootstrap();
        bootstrap.group(group)
                .channel(NioDatagramChannel.class)
                .option(ChannelOption.SO_BROADCAST, true)
                .handler(new ChannelInitializer<DatagramChannel>() {
                    @Override
                    protected void initChannel(DatagramChannel ch) throws Exception {
                        ch.pipeline().addLast(new RIPPacketEncoder());
                    }
                });
    }

    public void sendRipPacket(RIPPacket packet) {
        try {
            ChannelFuture future = bootstrap.bind(0).sync();
            future.channel().writeAndFlush(packet).sync();
            future.channel().close();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    public void shutdown() {
        group.shutdownGracefully();
    }
}
