package cn.x47.service;



import cn.x47.model.RIPEntry;

import java.net.InetAddress;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

public class RoutingTable {
    private static RoutingTable instance = new RoutingTable();
    private Map<InetAddress, RIPEntry> routes;

    private RoutingTable() {
        routes = new ConcurrentHashMap<>();
    }

    public static RoutingTable getInstance() {
        return instance;
    }

    public void updateRoute(RIPEntry entry) {
        // 简单地将新路由添加或更新到路由表中
        routes.put(entry.getIpAddress(), entry);
    }

    public void removeRoute(InetAddress ipAddress) {
        routes.remove(ipAddress);
    }

    public Map<InetAddress, RIPEntry> getRoutes() {
        return routes;
    }
}
