import java.net.*;
import java.io.*;

public class RipV1Response {

    public static void main(String[] args) {
        try {
            // 创建一个数据包
            byte[] packet = createRipV1ResponsePacket();

            // 创建一个UDP Socket
//            DatagramSocket socket = new DatagramSocket();
            // 创建一个UDP Socket，并将其绑定到指定的 IP 地址
            DatagramSocket socket = new DatagramSocket(null);
            socket.bind(new InetSocketAddress(InetAddress.getByName("192.168.123.45"), 520)); // 使用特定的本地 IP 地址绑定端口


            InetAddress address = InetAddress.getByName("224.0.0.9"); // RIPv1 默认的多播地址

            // 创建一个DatagramPacket并发送
            DatagramPacket sendPacket = new DatagramPacket(packet, packet.length, address, 520); // RIPv1 默认端口 520
            socket.send(sendPacket);

            System.out.println("RIP v1 Response packet sent!");
            socket.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    // 构建RIP v1 响应数据包
    public static byte[] createRipV1ResponsePacket() {
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        DataOutputStream dos = new DataOutputStream(bos);

        try {
            // 1. Command (8比特) - 响应报文 (Response)
            dos.writeByte(2); // Command = 2，表示响应报文

            // 2. Version (8比特) - RIP版本号 (RIP-1)
            dos.writeByte(1); // Version = 1，RIP-1

            // 3. Must be zero (16比特) - 保留字段，必须为零
            dos.writeShort(0); // 16比特的保留字段，填充0

            // 4. AFI (Address Family Identifier) (16比特) - 地址族标识符
            dos.writeShort(2); // AFI = 2，表示 IPv4 地址

            dos.writeShort(0);

            InetAddress byName = InetAddress.getByName("200.0.2.0");
            // 5. IP Address (32比特) - 路由目标 IP 地址
            dos.write(byName.getAddress()); // 192.168.0.1 的 IP 地址（32位）

            dos.writeInt(0);
            dos.writeInt(0);
            // 6. Metric (32比特) - 路由开销
            dos.writeInt(1); // Metric = 1，表示一个跳数

        } catch (IOException e) {
            e.printStackTrace();
        }

        return bos.toByteArray();
    }
}
